/* Copyright (C) 2009, Arne König
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "aieasy.h"
#include <stdio.h>

AIEasy::AIEasy(TPlayer _player, const Board& _board) : player (_player), board (_board) { }

AIEasy::~AIEasy () { }

TCoordCell
AIEasy::step(int starters) {
	TPlayer player;

	TCoordCell iterCell = TCoordCell(rand() % board.getWidth(), rand() % board.getHeight());
	TCoordCell startCell = iterCell;
	WeightedCoordCell cell(board), tmpCell(board);

	while(true) {
		if (board.isValidCell(iterCell)
				&& (starters != 0 || board.getCellPlayer(iterCell) != NONE_PLAYER)) {
			player = board.getCellPlayer(iterCell);
			if (player == NONE_PLAYER || player == this->player) {
				tmpCell = WeightedCoordCell(board, player, iterCell);
				if (cell < tmpCell) {
					cell = tmpCell;
				}
			}
		}
		iterCell.col = (iterCell.col + 1) % board.getWidth();
		if (iterCell.col == startCell.col) {
			iterCell.row = (iterCell.row + 1) % board.getHeight();
			if (iterCell.row == startCell.row)
				break;
		}
	}
	return TCoordCell(cell);

}

