/* Copyright (C) 2009, Arne König
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "audio.h"

mm_sound_effect colorSound = { SFX_COLOR, 1<<10, 0, 255, 127};
mm_sound_effect endSound = { SFX_END, 1<<10, 0, 220, 127};

Audio::Audio() {
	mmInitDefaultMem( (mm_addr)soundbank_bin );
	mmSetModuleVolume(800);
	mmLoad(MOD_BGMUSIC);
	mmLoadEffect(SFX_COLOR);
	mmLoadEffect(SFX_END);
	this->update(ALL_OPTION);
}

void 
Audio::update(TSoundOption mode) {
	this->mode = mode;
	if (mode & MUSIC_OPTION)
		startBgMusic();
	else
		stopBgMusic();
}

void
Audio::startBgMusic() {
	if (!mmActive())
		mmStart(MOD_BGMUSIC, MM_PLAY_LOOP);
}

void
Audio::stopBgMusic() {
	if (mmActive())
		mmStop();
}

void
Audio::playColorSound(mm_hword rate) {
	colorSound.rate = rate;
	if (mode & EFFECTS_OPTION)
		mmEffectEx(&colorSound);
}

void
Audio::playEndSound() {
	if (mode & EFFECTS_OPTION)
		mmEffectEx(&endSound);
}
