/* Copyright (C) 2009, Arne König
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "player.h"

Player::Player(TPlayer type, int starters) {
	this->type = type;
	this->starters = starters;
}

TPlayer
Player::getType() const {
	return this->type;
}

bool
Player::hasStarter() const {
	return (starters != 0);
}

void
Player::useStarter() {
	if (starters == -1) // infinite starters
		return;
	starters --;
}

int
Player::startersLeft() const {
	return starters;
}
